#include "php_gtk.h"
#if HAVE_PHP_GTK

void php_gdk_register_constants(int module_number TSRMLS_DC)
{

	/* enum GdkRgbDither */
	REGISTER_LONG_CONSTANT("GDK_RGB_DITHER_NONE", GDK_RGB_DITHER_NONE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_RGB_DITHER_NORMAL", GDK_RGB_DITHER_NORMAL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_RGB_DITHER_MAX", GDK_RGB_DITHER_MAX, CONST_CS | CONST_PERSISTENT);

	/* enum GdkWindowType */
	REGISTER_LONG_CONSTANT("GDK_WINDOW_ROOT", GDK_WINDOW_ROOT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_WINDOW_TOPLEVEL", GDK_WINDOW_TOPLEVEL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_WINDOW_CHILD", GDK_WINDOW_CHILD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_WINDOW_DIALOG", GDK_WINDOW_DIALOG, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_WINDOW_TEMP", GDK_WINDOW_TEMP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_WINDOW_PIXMAP", GDK_WINDOW_PIXMAP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_WINDOW_FOREIGN", GDK_WINDOW_FOREIGN, CONST_CS | CONST_PERSISTENT);

	/* enum GdkWindowClass */
	REGISTER_LONG_CONSTANT("GDK_INPUT_OUTPUT", GDK_INPUT_OUTPUT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_INPUT_ONLY", GDK_INPUT_ONLY, CONST_CS | CONST_PERSISTENT);

	/* enum GdkImageType */
	REGISTER_LONG_CONSTANT("GDK_IMAGE_NORMAL", GDK_IMAGE_NORMAL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IMAGE_SHARED", GDK_IMAGE_SHARED, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IMAGE_FASTEST", GDK_IMAGE_FASTEST, CONST_CS | CONST_PERSISTENT);

	/* enum GdkVisualType */
	REGISTER_LONG_CONSTANT("GDK_VISUAL_STATIC_GRAY", GDK_VISUAL_STATIC_GRAY, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_VISUAL_GRAYSCALE", GDK_VISUAL_GRAYSCALE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_VISUAL_STATIC_COLOR", GDK_VISUAL_STATIC_COLOR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_VISUAL_PSEUDO_COLOR", GDK_VISUAL_PSEUDO_COLOR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_VISUAL_TRUE_COLOR", GDK_VISUAL_TRUE_COLOR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_VISUAL_DIRECT_COLOR", GDK_VISUAL_DIRECT_COLOR, CONST_CS | CONST_PERSISTENT);

	/* enum GdkFontType */
	REGISTER_LONG_CONSTANT("GDK_FONT_FONT", GDK_FONT_FONT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_FONT_FONTSET", GDK_FONT_FONTSET, CONST_CS | CONST_PERSISTENT);

	/* flags GdkWindowAttributesType */
	REGISTER_LONG_CONSTANT("GDK_WA_TITLE", GDK_WA_TITLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_WA_X", GDK_WA_X, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_WA_Y", GDK_WA_Y, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_WA_CURSOR", GDK_WA_CURSOR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_WA_COLORMAP", GDK_WA_COLORMAP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_WA_VISUAL", GDK_WA_VISUAL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_WA_WMCLASS", GDK_WA_WMCLASS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_WA_NOREDIR", GDK_WA_NOREDIR, CONST_CS | CONST_PERSISTENT);

	/* flags GdkWindowHints */
	REGISTER_LONG_CONSTANT("GDK_HINT_POS", GDK_HINT_POS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_HINT_MIN_SIZE", GDK_HINT_MIN_SIZE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_HINT_MAX_SIZE", GDK_HINT_MAX_SIZE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_HINT_BASE_SIZE", GDK_HINT_BASE_SIZE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_HINT_ASPECT", GDK_HINT_ASPECT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_HINT_RESIZE_INC", GDK_HINT_RESIZE_INC, CONST_CS | CONST_PERSISTENT);

	/* enum GdkFunction */
	REGISTER_LONG_CONSTANT("GDK_COPY", GDK_COPY, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_INVERT", GDK_INVERT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_XOR", GDK_XOR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_CLEAR", GDK_CLEAR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_AND", GDK_AND, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_AND_REVERSE", GDK_AND_REVERSE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_AND_INVERT", GDK_AND_INVERT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_NOOP", GDK_NOOP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_OR", GDK_OR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_EQUIV", GDK_EQUIV, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_OR_REVERSE", GDK_OR_REVERSE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_COPY_INVERT", GDK_COPY_INVERT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_OR_INVERT", GDK_OR_INVERT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_NAND", GDK_NAND, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_SET", GDK_SET, CONST_CS | CONST_PERSISTENT);

	/* enum GdkFill */
	REGISTER_LONG_CONSTANT("GDK_SOLID", GDK_SOLID, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_TILED", GDK_TILED, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_STIPPLED", GDK_STIPPLED, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_OPAQUE_STIPPLED", GDK_OPAQUE_STIPPLED, CONST_CS | CONST_PERSISTENT);

	/* enum GdkFillRule */
	REGISTER_LONG_CONSTANT("GDK_EVEN_ODD_RULE", GDK_EVEN_ODD_RULE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_WINDING_RULE", GDK_WINDING_RULE, CONST_CS | CONST_PERSISTENT);

	/* enum GdkLineStyle */
	REGISTER_LONG_CONSTANT("GDK_LINE_SOLID", GDK_LINE_SOLID, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_LINE_ON_OFF_DASH", GDK_LINE_ON_OFF_DASH, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_LINE_DOUBLE_DASH", GDK_LINE_DOUBLE_DASH, CONST_CS | CONST_PERSISTENT);

	/* enum GdkCapStyle */
	REGISTER_LONG_CONSTANT("GDK_CAP_NOT_LAST", GDK_CAP_NOT_LAST, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_CAP_BUTT", GDK_CAP_BUTT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_CAP_ROUND", GDK_CAP_ROUND, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_CAP_PROJECTING", GDK_CAP_PROJECTING, CONST_CS | CONST_PERSISTENT);

	/* enum GdkJoinStyle */
	REGISTER_LONG_CONSTANT("GDK_JOIN_MITER", GDK_JOIN_MITER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_JOIN_ROUND", GDK_JOIN_ROUND, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_JOIN_BEVEL", GDK_JOIN_BEVEL, CONST_CS | CONST_PERSISTENT);

	/* enum GdkCursorType */
	REGISTER_LONG_CONSTANT("GDK_CURSOR_IS_PIXMAP", GDK_CURSOR_IS_PIXMAP, CONST_CS | CONST_PERSISTENT);

	/* enum GdkFilterReturn */
	REGISTER_LONG_CONSTANT("GDK_FILTER_CONTINUE", GDK_FILTER_CONTINUE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_FILTER_TRANSLATE", GDK_FILTER_TRANSLATE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_FILTER_REMOVE", GDK_FILTER_REMOVE, CONST_CS | CONST_PERSISTENT);

	/* enum GdkVisibilityState */
	REGISTER_LONG_CONSTANT("GDK_VISIBILITY_UNOBSCURED", GDK_VISIBILITY_UNOBSCURED, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_VISIBILITY_PARTIAL", GDK_VISIBILITY_PARTIAL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_VISIBILITY_FULLY_OBSCURED", GDK_VISIBILITY_FULLY_OBSCURED, CONST_CS | CONST_PERSISTENT);

	/* enum GdkEventType */
	REGISTER_LONG_CONSTANT("GDK_NOTHING", GDK_NOTHING, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_DELETE", GDK_DELETE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_DESTROY", GDK_DESTROY, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_EXPOSE", GDK_EXPOSE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_MOTION_NOTIFY", GDK_MOTION_NOTIFY, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_BUTTON_PRESS", GDK_BUTTON_PRESS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_2BUTTON_PRESS", GDK_2BUTTON_PRESS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_3BUTTON_PRESS", GDK_3BUTTON_PRESS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_BUTTON_RELEASE", GDK_BUTTON_RELEASE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_PRESS", GDK_KEY_PRESS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_RELEASE", GDK_KEY_RELEASE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_ENTER_NOTIFY", GDK_ENTER_NOTIFY, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_LEAVE_NOTIFY", GDK_LEAVE_NOTIFY, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_FOCUS_CHANGE", GDK_FOCUS_CHANGE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_CONFIGURE", GDK_CONFIGURE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_MAP", GDK_MAP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_UNMAP", GDK_UNMAP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_PROPERTY_NOTIFY", GDK_PROPERTY_NOTIFY, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_SELECTION_CLEAR", GDK_SELECTION_CLEAR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_SELECTION_REQUEST", GDK_SELECTION_REQUEST, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_SELECTION_NOTIFY", GDK_SELECTION_NOTIFY, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_PROXIMITY_IN", GDK_PROXIMITY_IN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_PROXIMITY_OUT", GDK_PROXIMITY_OUT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_DRAG_ENTER", GDK_DRAG_ENTER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_DRAG_LEAVE", GDK_DRAG_LEAVE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_DRAG_MOTION", GDK_DRAG_MOTION, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_DRAG_STATUS", GDK_DRAG_STATUS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_DROP_START", GDK_DROP_START, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_DROP_FINISHED", GDK_DROP_FINISHED, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_CLIENT_EVENT", GDK_CLIENT_EVENT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_VISIBILITY_NOTIFY", GDK_VISIBILITY_NOTIFY, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_NO_EXPOSE", GDK_NO_EXPOSE, CONST_CS | CONST_PERSISTENT);

	/* flags GdkEventMask */
	REGISTER_LONG_CONSTANT("GDK_EXPOSURE_MASK", GDK_EXPOSURE_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_POINTER_MOTION_MASK", GDK_POINTER_MOTION_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_POINTER_MOTION_HINT_MASK", GDK_POINTER_MOTION_HINT_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_BUTTON_MOTION_MASK", GDK_BUTTON_MOTION_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_BUTTON1_MOTION_MASK", GDK_BUTTON1_MOTION_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_BUTTON2_MOTION_MASK", GDK_BUTTON2_MOTION_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_BUTTON3_MOTION_MASK", GDK_BUTTON3_MOTION_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_BUTTON_PRESS_MASK", GDK_BUTTON_PRESS_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_BUTTON_RELEASE_MASK", GDK_BUTTON_RELEASE_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_PRESS_MASK", GDK_KEY_PRESS_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_RELEASE_MASK", GDK_KEY_RELEASE_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_ENTER_NOTIFY_MASK", GDK_ENTER_NOTIFY_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_LEAVE_NOTIFY_MASK", GDK_LEAVE_NOTIFY_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_FOCUS_CHANGE_MASK", GDK_FOCUS_CHANGE_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_STRUCTURE_MASK", GDK_STRUCTURE_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_PROPERTY_CHANGE_MASK", GDK_PROPERTY_CHANGE_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_VISIBILITY_NOTIFY_MASK", GDK_VISIBILITY_NOTIFY_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_PROXIMITY_IN_MASK", GDK_PROXIMITY_IN_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_PROXIMITY_OUT_MASK", GDK_PROXIMITY_OUT_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_SUBSTRUCTURE_MASK", GDK_SUBSTRUCTURE_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_ALL_EVENTS_MASK", GDK_ALL_EVENTS_MASK, CONST_CS | CONST_PERSISTENT);

	/* enum GdkNotifyType */
	REGISTER_LONG_CONSTANT("GDK_NOTIFY_ANCESTOR", GDK_NOTIFY_ANCESTOR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_NOTIFY_VIRTUAL", GDK_NOTIFY_VIRTUAL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_NOTIFY_INFERIOR", GDK_NOTIFY_INFERIOR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_NOTIFY_NONLINEAR", GDK_NOTIFY_NONLINEAR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_NOTIFY_NONLINEAR_VIRTUAL", GDK_NOTIFY_NONLINEAR_VIRTUAL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_NOTIFY_UNKNOWN", GDK_NOTIFY_UNKNOWN, CONST_CS | CONST_PERSISTENT);

	/* enum GdkCrossingMode */
	REGISTER_LONG_CONSTANT("GDK_CROSSING_NORMAL", GDK_CROSSING_NORMAL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_CROSSING_GRAB", GDK_CROSSING_GRAB, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_CROSSING_UNGRAB", GDK_CROSSING_UNGRAB, CONST_CS | CONST_PERSISTENT);

	/* flags GdkModifierType */
	REGISTER_LONG_CONSTANT("GDK_SHIFT_MASK", GDK_SHIFT_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_LOCK_MASK", GDK_LOCK_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_CONTROL_MASK", GDK_CONTROL_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_MOD1_MASK", GDK_MOD1_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_MOD2_MASK", GDK_MOD2_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_MOD3_MASK", GDK_MOD3_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_MOD4_MASK", GDK_MOD4_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_MOD5_MASK", GDK_MOD5_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_BUTTON1_MASK", GDK_BUTTON1_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_BUTTON2_MASK", GDK_BUTTON2_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_BUTTON3_MASK", GDK_BUTTON3_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_BUTTON4_MASK", GDK_BUTTON4_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_BUTTON5_MASK", GDK_BUTTON5_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_RELEASE_MASK", GDK_RELEASE_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_MODIFIER_MASK", GDK_MODIFIER_MASK, CONST_CS | CONST_PERSISTENT);

	/* enum GdkSubwindowMode */
	REGISTER_LONG_CONSTANT("GDK_CLIP_BY_CHILDREN", GDK_CLIP_BY_CHILDREN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_INCLUDE_INFERIORS", GDK_INCLUDE_INFERIORS, CONST_CS | CONST_PERSISTENT);

	/* flags GdkInputCondition */
	REGISTER_LONG_CONSTANT("GDK_INPUT_READ", GDK_INPUT_READ, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_INPUT_WRITE", GDK_INPUT_WRITE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_INPUT_EXCEPTION", GDK_INPUT_EXCEPTION, CONST_CS | CONST_PERSISTENT);

	/* enum GdkStatus */
	REGISTER_LONG_CONSTANT("GDK_OK", GDK_OK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_ERROR", GDK_ERROR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_ERROR_PARAM", GDK_ERROR_PARAM, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_ERROR_FILE", GDK_ERROR_FILE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_ERROR_MEM", GDK_ERROR_MEM, CONST_CS | CONST_PERSISTENT);

	/* enum GdkByteOrder */
	REGISTER_LONG_CONSTANT("GDK_LSB_FIRST", GDK_LSB_FIRST, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_MSB_FIRST", GDK_MSB_FIRST, CONST_CS | CONST_PERSISTENT);

	/* flags GdkGCValuesMask */
	REGISTER_LONG_CONSTANT("GDK_GC_FOREGROUND", GDK_GC_FOREGROUND, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_GC_BACKGROUND", GDK_GC_BACKGROUND, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_GC_FONT", GDK_GC_FONT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_GC_FUNCTION", GDK_GC_FUNCTION, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_GC_FILL", GDK_GC_FILL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_GC_TILE", GDK_GC_TILE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_GC_STIPPLE", GDK_GC_STIPPLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_GC_CLIP_MASK", GDK_GC_CLIP_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_GC_SUBWINDOW", GDK_GC_SUBWINDOW, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_GC_TS_X_ORIGIN", GDK_GC_TS_X_ORIGIN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_GC_TS_Y_ORIGIN", GDK_GC_TS_Y_ORIGIN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_GC_CLIP_X_ORIGIN", GDK_GC_CLIP_X_ORIGIN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_GC_CLIP_Y_ORIGIN", GDK_GC_CLIP_Y_ORIGIN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_GC_EXPOSURES", GDK_GC_EXPOSURES, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_GC_LINE_WIDTH", GDK_GC_LINE_WIDTH, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_GC_LINE_STYLE", GDK_GC_LINE_STYLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_GC_CAP_STYLE", GDK_GC_CAP_STYLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_GC_JOIN_STYLE", GDK_GC_JOIN_STYLE, CONST_CS | CONST_PERSISTENT);

	/* enum GdkSelection */
	REGISTER_LONG_CONSTANT("GDK_SELECTION_PRIMARY", GDK_SELECTION_PRIMARY, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_SELECTION_SECONDARY", GDK_SELECTION_SECONDARY, CONST_CS | CONST_PERSISTENT);

	/* enum GdkPropertyState */
	REGISTER_LONG_CONSTANT("GDK_PROPERTY_NEW_VALUE", GDK_PROPERTY_NEW_VALUE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_PROPERTY_DELETE", GDK_PROPERTY_DELETE, CONST_CS | CONST_PERSISTENT);

	/* enum GdkPropMode */
	REGISTER_LONG_CONSTANT("GDK_PROP_MODE_REPLACE", GDK_PROP_MODE_REPLACE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_PROP_MODE_PREPEND", GDK_PROP_MODE_PREPEND, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_PROP_MODE_APPEND", GDK_PROP_MODE_APPEND, CONST_CS | CONST_PERSISTENT);

	/* enum GdkInputSource */
	REGISTER_LONG_CONSTANT("GDK_SOURCE_MOUSE", GDK_SOURCE_MOUSE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_SOURCE_PEN", GDK_SOURCE_PEN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_SOURCE_ERASER", GDK_SOURCE_ERASER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_SOURCE_CURSOR", GDK_SOURCE_CURSOR, CONST_CS | CONST_PERSISTENT);

	/* enum GdkInputMode */
	REGISTER_LONG_CONSTANT("GDK_MODE_DISABLED", GDK_MODE_DISABLED, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_MODE_SCREEN", GDK_MODE_SCREEN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_MODE_WINDOW", GDK_MODE_WINDOW, CONST_CS | CONST_PERSISTENT);

	/* enum GdkAxisUse */
	REGISTER_LONG_CONSTANT("GDK_AXIS_IGNORE", GDK_AXIS_IGNORE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_AXIS_X", GDK_AXIS_X, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_AXIS_Y", GDK_AXIS_Y, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_AXIS_PRESSURE", GDK_AXIS_PRESSURE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_AXIS_XTILT", GDK_AXIS_XTILT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_AXIS_YTILT", GDK_AXIS_YTILT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_AXIS_LAST", GDK_AXIS_LAST, CONST_CS | CONST_PERSISTENT);

	/* enum GdkTarget */
	REGISTER_LONG_CONSTANT("GDK_TARGET_BITMAP", GDK_TARGET_BITMAP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_TARGET_COLORMAP", GDK_TARGET_COLORMAP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_TARGET_DRAWABLE", GDK_TARGET_DRAWABLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_TARGET_PIXMAP", GDK_TARGET_PIXMAP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_TARGET_STRING", GDK_TARGET_STRING, CONST_CS | CONST_PERSISTENT);

	/* enum GdkSelectionType */
	REGISTER_LONG_CONSTANT("GDK_SELECTION_TYPE_ATOM", GDK_SELECTION_TYPE_ATOM, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_SELECTION_TYPE_BITMAP", GDK_SELECTION_TYPE_BITMAP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_SELECTION_TYPE_COLORMAP", GDK_SELECTION_TYPE_COLORMAP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_SELECTION_TYPE_DRAWABLE", GDK_SELECTION_TYPE_DRAWABLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_SELECTION_TYPE_INTEGER", GDK_SELECTION_TYPE_INTEGER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_SELECTION_TYPE_PIXMAP", GDK_SELECTION_TYPE_PIXMAP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_SELECTION_TYPE_WINDOW", GDK_SELECTION_TYPE_WINDOW, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_SELECTION_TYPE_STRING", GDK_SELECTION_TYPE_STRING, CONST_CS | CONST_PERSISTENT);

	/* enum GdkExtensionMode */
	REGISTER_LONG_CONSTANT("GDK_EXTENSION_EVENTS_NONE", GDK_EXTENSION_EVENTS_NONE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_EXTENSION_EVENTS_ALL", GDK_EXTENSION_EVENTS_ALL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_EXTENSION_EVENTS_CURSOR", GDK_EXTENSION_EVENTS_CURSOR, CONST_CS | CONST_PERSISTENT);

	/* enum GdkIMStyle */
	REGISTER_LONG_CONSTANT("GDK_IM_PREEDIT_AREA", GDK_IM_PREEDIT_AREA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IM_PREEDIT_CALLBACKS", GDK_IM_PREEDIT_CALLBACKS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IM_PREEDIT_POSITION", GDK_IM_PREEDIT_POSITION, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IM_PREEDIT_NOTHING", GDK_IM_PREEDIT_NOTHING, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IM_PREEDIT_NONE", GDK_IM_PREEDIT_NONE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IM_PREEDIT_MASK", GDK_IM_PREEDIT_MASK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IM_STATUS_AREA", GDK_IM_STATUS_AREA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IM_STATUS_CALLBACKS", GDK_IM_STATUS_CALLBACKS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IM_STATUS_NOTHING", GDK_IM_STATUS_NOTHING, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IM_STATUS_NONE", GDK_IM_STATUS_NONE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IM_STATUS_MASK", GDK_IM_STATUS_MASK, CONST_CS | CONST_PERSISTENT);

	/* flags GdkICAttributesType */
	REGISTER_LONG_CONSTANT("GDK_IC_STYLE", GDK_IC_STYLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IC_CLIENT_WINDOW", GDK_IC_CLIENT_WINDOW, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IC_FOCUS_WINDOW", GDK_IC_FOCUS_WINDOW, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IC_FILTER_EVENTS", GDK_IC_FILTER_EVENTS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IC_SPOT_LOCATION", GDK_IC_SPOT_LOCATION, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IC_LINE_SPACING", GDK_IC_LINE_SPACING, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IC_CURSOR", GDK_IC_CURSOR, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IC_PREEDIT_FONTSET", GDK_IC_PREEDIT_FONTSET, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IC_PREEDIT_AREA", GDK_IC_PREEDIT_AREA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IC_PREEDIT_AREA_NEEDED", GDK_IC_PREEDIT_AREA_NEEDED, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IC_PREEDIT_FOREGROUND", GDK_IC_PREEDIT_FOREGROUND, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IC_PREEDIT_BACKGROUND", GDK_IC_PREEDIT_BACKGROUND, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IC_PREEDIT_PIXMAP", GDK_IC_PREEDIT_PIXMAP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IC_PREEDIT_COLORMAP", GDK_IC_PREEDIT_COLORMAP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IC_STATUS_FONTSET", GDK_IC_STATUS_FONTSET, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IC_STATUS_AREA", GDK_IC_STATUS_AREA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IC_STATUS_AREA_NEEDED", GDK_IC_STATUS_AREA_NEEDED, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IC_STATUS_FOREGROUND", GDK_IC_STATUS_FOREGROUND, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IC_STATUS_BACKGROUND", GDK_IC_STATUS_BACKGROUND, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IC_STATUS_PIXMAP", GDK_IC_STATUS_PIXMAP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IC_STATUS_COLORMAP", GDK_IC_STATUS_COLORMAP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IC_ALL_REQ", GDK_IC_ALL_REQ, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IC_PREEDIT_AREA_REQ", GDK_IC_PREEDIT_AREA_REQ, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IC_PREEDIT_POSITION_REQ", GDK_IC_PREEDIT_POSITION_REQ, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_IC_STATUS_AREA_REQ", GDK_IC_STATUS_AREA_REQ, CONST_CS | CONST_PERSISTENT);

	/* flags GdkWMDecoration */
	REGISTER_LONG_CONSTANT("GDK_DECOR_ALL", GDK_DECOR_ALL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_DECOR_BORDER", GDK_DECOR_BORDER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_DECOR_RESIZEH", GDK_DECOR_RESIZEH, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_DECOR_TITLE", GDK_DECOR_TITLE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_DECOR_MENU", GDK_DECOR_MENU, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_DECOR_MINIMIZE", GDK_DECOR_MINIMIZE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_DECOR_MAXIMIZE", GDK_DECOR_MAXIMIZE, CONST_CS | CONST_PERSISTENT);

	/* flags GdkWMFunction */
	REGISTER_LONG_CONSTANT("GDK_FUNC_ALL", GDK_FUNC_ALL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_FUNC_RESIZE", GDK_FUNC_RESIZE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_FUNC_MOVE", GDK_FUNC_MOVE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_FUNC_MINIMIZE", GDK_FUNC_MINIMIZE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_FUNC_MAXIMIZE", GDK_FUNC_MAXIMIZE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_FUNC_CLOSE", GDK_FUNC_CLOSE, CONST_CS | CONST_PERSISTENT);

	/* enum GdkColorContextMode */
	REGISTER_LONG_CONSTANT("GDK_CC_MODE_UNDEFINED", GDK_CC_MODE_UNDEFINED, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_CC_MODE_BW", GDK_CC_MODE_BW, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_CC_MODE_STD_CMAP", GDK_CC_MODE_STD_CMAP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_CC_MODE_TRUE", GDK_CC_MODE_TRUE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_CC_MODE_MY_GRAY", GDK_CC_MODE_MY_GRAY, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_CC_MODE_PALETTE", GDK_CC_MODE_PALETTE, CONST_CS | CONST_PERSISTENT);

	/* enum GdkOverlapType */
	REGISTER_LONG_CONSTANT("GDK_OVERLAP_RECTANGLE_IN", GDK_OVERLAP_RECTANGLE_IN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_OVERLAP_RECTANGLE_OUT", GDK_OVERLAP_RECTANGLE_OUT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_OVERLAP_RECTANGLE_PART", GDK_OVERLAP_RECTANGLE_PART, CONST_CS | CONST_PERSISTENT);

	/* flags GdkDragAction */
	REGISTER_LONG_CONSTANT("GDK_ACTION_DEFAULT", GDK_ACTION_DEFAULT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_ACTION_COPY", GDK_ACTION_COPY, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_ACTION_MOVE", GDK_ACTION_MOVE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_ACTION_LINK", GDK_ACTION_LINK, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_ACTION_PRIVATE", GDK_ACTION_PRIVATE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_ACTION_ASK", GDK_ACTION_ASK, CONST_CS | CONST_PERSISTENT);

	/* enum GdkDragProtocol */
	REGISTER_LONG_CONSTANT("GDK_DRAG_PROTO_MOTIF", GDK_DRAG_PROTO_MOTIF, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_DRAG_PROTO_XDND", GDK_DRAG_PROTO_XDND, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_DRAG_PROTO_ROOTWIN", GDK_DRAG_PROTO_ROOTWIN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_DRAG_PROTO_NONE", GDK_DRAG_PROTO_NONE, CONST_CS | CONST_PERSISTENT);
}

PHP_GTK_EXPORT_CE(gdk_rectangle_ce);

PHP_FUNCTION(gdk_get_display)
{
	gchar *ret;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	ret = gdk_get_display();
	if (ret) {
		RETURN_STRING(ret, 1);
		g_free(ret);
	} else
		RETURN_NULL();
}


PHP_FUNCTION(gdk_input_remove)
{
	long tag;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &tag))
		return;

	gdk_input_remove((gint)tag);
	RETURN_NULL();
}


PHP_FUNCTION(gdk_pointer_grab)
{
	zval *window, *php_event_mask = NULL, *php_confine_to, *php_cursor;
	long owner_events, time, php_retval;
	GdkEventMask event_mask;
	GdkWindow *confine_to = NULL;
	GdkCursor *cursor = NULL;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "OiVNNi", &window, gdk_window_ce, &owner_events, &php_event_mask, &php_confine_to, gdk_window_ce, &php_cursor, gdk_cursor_ce, &time))
		return;

	if (php_event_mask && !php_gtk_get_flag_value(GTK_TYPE_GDK_EVENT_MASK, php_event_mask, (gint *)&event_mask)) {
		return;
	}

	if (Z_TYPE_P(php_confine_to) != IS_NULL)
		confine_to = PHP_GDK_WINDOW_GET(php_confine_to);
	if (Z_TYPE_P(php_cursor) != IS_NULL)
		cursor = PHP_GDK_CURSOR_GET(php_cursor);
	php_retval = gdk_pointer_grab(PHP_GDK_WINDOW_GET(window), (gint)owner_events, event_mask, confine_to, cursor, (guint32)time);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gdk_pointer_ungrab)
{
	long time;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &time))
		return;

	gdk_pointer_ungrab((guint32)time);
	RETURN_NULL();
}


PHP_FUNCTION(gdk_keyboard_grab)
{
	zval *window;
	zend_bool owner_events;
	long time, php_retval;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "Obi", &window, gdk_window_ce, &owner_events, &time))
		return;

	php_retval = gdk_keyboard_grab(PHP_GDK_WINDOW_GET(window), (gboolean)owner_events, (guint32)time);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gdk_keyboard_ungrab)
{
	long time;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &time))
		return;

	gdk_keyboard_ungrab((guint32)time);
	RETURN_NULL();
}


PHP_FUNCTION(gdk_pointer_is_grabbed)
{
	gboolean php_retval;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gdk_pointer_is_grabbed();
	RETURN_BOOL(php_retval);
}


PHP_FUNCTION(gdk_screen_width)
{
	long php_retval;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gdk_screen_width();
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gdk_screen_height)
{
	long php_retval;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gdk_screen_height();
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gdk_screen_width_mm)
{
	long php_retval;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gdk_screen_width_mm();
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gdk_screen_height_mm)
{
	long php_retval;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gdk_screen_height_mm();
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gdk_flush)
{
	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gdk_flush();
	RETURN_NULL();
}


PHP_FUNCTION(gdk_beep)
{
	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gdk_beep();
	RETURN_NULL();
}


PHP_FUNCTION(gdk_visual_get_system)
{
	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	PHP_GTK_SEPARATE_RETURN(return_value, php_gdk_visual_new(gdk_visual_get_system()));
	return;
}


PHP_FUNCTION(gdk_visual_get_best)
{
	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	PHP_GTK_SEPARATE_RETURN(return_value, php_gdk_visual_new(gdk_visual_get_best()));
	return;
}


PHP_FUNCTION(gdk_visual_get_best_with_depth)
{
	long depth;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &depth))
		return;

	PHP_GTK_SEPARATE_RETURN(return_value, php_gdk_visual_new(gdk_visual_get_best_with_depth((gint)depth)));
	return;
}


PHP_FUNCTION(gdk_visual_get_best_with_type)
{
	GdkVisualType visual_type;
	zval *php_visual_type = NULL;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "V", &php_visual_type))
		return;

	if (php_visual_type && !php_gtk_get_enum_value(GTK_TYPE_GDK_VISUAL_TYPE, php_visual_type, (gint *)&visual_type)) {
		return;
	}

	PHP_GTK_SEPARATE_RETURN(return_value, php_gdk_visual_new(gdk_visual_get_best_with_type(visual_type)));
	return;
}


PHP_FUNCTION(gdk_visual_get_best_with_both)
{
	long depth;
	GdkVisualType visual_type;
	zval *php_visual_type = NULL;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "iV", &depth, &php_visual_type))
		return;

	if (php_visual_type && !php_gtk_get_enum_value(GTK_TYPE_GDK_VISUAL_TYPE, php_visual_type, (gint *)&visual_type)) {
		return;
	}

	PHP_GTK_SEPARATE_RETURN(return_value, php_gdk_visual_new(gdk_visual_get_best_with_both((gint)depth, visual_type)));
	return;
}


PHP_FUNCTION(gdk_drag_status)
{
	zval *context, *php_action = NULL;
	GdkDragAction action;
	long time;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "OVi", &context, gdk_drag_context_ce, &php_action, &time))
		return;

	if (php_action && !php_gtk_get_flag_value(GTK_TYPE_GDK_DRAG_ACTION, php_action, (gint *)&action)) {
		return;
	}

	gdk_drag_status(PHP_GDK_DRAG_CONTEXT_GET(context), action, (guint32)time);
	RETURN_NULL();
}


PHP_FUNCTION(gdk_cursor_new)
{
	GdkCursorType cursor_type;
	zval *php_cursor_type = NULL;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "V", &php_cursor_type))
		return;

	if (php_cursor_type && !php_gtk_get_enum_value(GTK_TYPE_GDK_CURSOR_TYPE, php_cursor_type, (gint *)&cursor_type)) {
		return;
	}

	PHP_GTK_SEPARATE_RETURN(return_value, php_gdk_cursor_new(gdk_cursor_new(cursor_type)));
	return;
}

PHP_FUNCTION(gdk_cursor_new_from_pixmap)
{
    zval *source, *mask, *fg, *bg;
    long x, y,i,j;
    int width,height;
    GdkPixmap *dest;
    GdkWindow *swin;
    GdkGC *gc;
    GdkImage *simage, *dimage;
    guint32 pixel;
                                                                                                                           
    if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "OOOOii", &source, gdk_pixmap_ce,
                            &mask, gdk_bitmap_ce, &fg, gdk_color_ce, &bg,
                            gdk_color_ce, &x, &y)) {
        return;
    }
                                                                                                                           
    swin = PHP_GDK_WINDOW_GET(source);
    gdk_window_get_size(swin, &width, &height);
    simage = gdk_image_get(swin, 0, 0, width, height);
    dest = gdk_pixmap_new(NULL, width, height, 1);
    dimage = gdk_image_get(dest, 0, 0, width, height);
                                                                                                                           
    for (i = 0; i < height; i++) {
        for (j = 0; j < width; j++) {
            pixel = gdk_image_get_pixel(simage, j, i);
            gdk_image_put_pixel(dimage, j, i, (pixel > 0));
        }
    }
    gc = gdk_gc_new(dest);
    gdk_draw_image(dest, gc, dimage, 0, 0, 0, 0, width, height);
                                                                                                                           
    PHP_GTK_SEPARATE_RETURN(return_value, php_gdk_cursor_new(gdk_cursor_new_from_pixmap(dest, PHP_GDK_BITMAP_GET(mask), PHP_GDK_COLOR_GET(fg), PHP_GDK_COLOR_GET(bg), (gint)x, (gint)y)));
                                                                                                                           
    /* cleanup */
    gdk_gc_unref(gc);
    gdk_image_destroy(simage);
    gdk_image_destroy(dimage);
    gdk_pixmap_unref(dest);
}
PHP_FUNCTION(gdk_pixmap_create_from_xpm)
{
	zval *php_window, *php_trans_color;
	gchar *filename;
	GdkWindow *window = NULL;
	GdkColor *trans_color = NULL;
	GdkPixmap *pixmap = NULL;
	GdkBitmap *mask;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "NNs", &php_window, gdk_window_ce,
							&php_trans_color, gdk_color_ce, &filename))
		return;

	if (Z_TYPE_P(php_window) != IS_NULL)
		window = PHP_GDK_WINDOW_GET(php_window);
	if (Z_TYPE_P(php_trans_color) != IS_NULL)
		trans_color = PHP_GDK_COLOR_GET(php_trans_color);

	pixmap = gdk_pixmap_create_from_xpm(window, &mask, trans_color, filename);
	if (!pixmap) {
		php_error(E_WARNING, "%s() cannot load pixmap", get_active_function_name(TSRMLS_C));
		return;
	}
	
	*return_value = *php_gtk_build_value("(NN)", php_gdk_pixmap_new(pixmap), php_gdk_bitmap_new(mask));
	gdk_pixmap_unref(pixmap);
	gdk_bitmap_unref(mask);
}
PHP_FUNCTION(gdk_pixmap_colormap_create_from_xpm)
{
	zval *php_window, *php_trans_color, *php_colormap;
	gchar *filename;
	GdkWindow *window = NULL;
	GdkColormap *colormap = NULL;
	GdkColor *trans_color = NULL;
	GdkPixmap *pixmap = NULL;
	GdkBitmap *mask;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "NNNs", &php_window, gdk_window_ce,
							&php_colormap, gdk_colormap_ce, &php_trans_color,
							gdk_color_ce, &filename))
		return;

	if (Z_TYPE_P(php_window) != IS_NULL)
		window = PHP_GDK_WINDOW_GET(php_window);
	if (Z_TYPE_P(php_colormap) != IS_NULL)
		colormap = PHP_GDK_COLORMAP_GET(php_colormap);
	if (Z_TYPE_P(php_trans_color) != IS_NULL)
		trans_color = PHP_GDK_COLOR_GET(php_trans_color);

	pixmap = gdk_pixmap_colormap_create_from_xpm(window, colormap, &mask, trans_color, filename);
	if (!pixmap) {
		php_error(E_WARNING, "%s() cannot load pixmap", get_active_function_name(TSRMLS_C));
		return;
	}

	*return_value = *php_gtk_build_value("(NN)", php_gdk_pixmap_new(pixmap), php_gdk_bitmap_new(mask));
	gdk_pixmap_unref(pixmap);
	gdk_bitmap_unref(mask);
}
PHP_FUNCTION(gdk_pixmap_create_from_xpm_d)
{
	zval *php_window, *php_trans_color, *php_data;
	zval **line;
	GdkWindow *window = NULL;
	GdkColor *trans_color = NULL;
	GdkPixmap *pixmap = NULL;
	GdkBitmap *mask;
	char **data;
	int len, i = 0;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "NNa/", &php_window, gdk_window_ce,
							&php_trans_color, gdk_color_ce, &php_data))
		return;

	if (Z_TYPE_P(php_window) != IS_NULL)
		window = PHP_GDK_WINDOW_GET(php_window);
	if (Z_TYPE_P(php_trans_color) != IS_NULL)
		trans_color = PHP_GDK_COLOR_GET(php_trans_color);

	len = zend_hash_num_elements(Z_ARRVAL_P(php_data));
	data = emalloc(len * sizeof(char *));
	for (zend_hash_internal_pointer_reset(Z_ARRVAL_P(php_data));
		 zend_hash_get_current_data(Z_ARRVAL_P(php_data), (void **)&line) == SUCCESS;
		 zend_hash_move_forward(Z_ARRVAL_P(php_data))) {
		convert_to_string_ex(line);
		data[i++] = Z_STRVAL_PP(line);
	}

	pixmap = gdk_pixmap_create_from_xpm_d(window, &mask, trans_color, data);
	efree(data);
	if (!pixmap) {
		php_error(E_WARNING, "%s() cannot create pixmap", get_active_function_name(TSRMLS_C));
		return;
	}

	*return_value = *php_gtk_build_value("(NN)", php_gdk_pixmap_new(pixmap), php_gdk_bitmap_new(mask));
	gdk_pixmap_unref(pixmap);
	gdk_bitmap_unref(mask);
}
PHP_FUNCTION(gdk_pixmap_colormap_create_from_xpm_d)
{
	zval *php_window, *php_colormap,
		 *php_trans_color, *php_data;
	zval **line;
	GdkWindow *window = NULL;
	GdkColormap *colormap = NULL;
	GdkColor *trans_color = NULL;
	GdkPixmap *pixmap = NULL;
	GdkBitmap *mask;
	char **data;
	int len, i = 0;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "NNNa/", &php_window,
							gdk_window_ce, &php_colormap, gdk_colormap_ce,
							&php_trans_color, gdk_color_ce, &php_data))
		return;

	if (Z_TYPE_P(php_window) != IS_NULL)
		window = PHP_GDK_WINDOW_GET(php_window);
	if (Z_TYPE_P(php_colormap) != IS_NULL)
		colormap = PHP_GDK_COLORMAP_GET(php_colormap);
	if (Z_TYPE_P(php_trans_color) != IS_NULL)
		trans_color = PHP_GDK_COLOR_GET(php_trans_color);

	len = zend_hash_num_elements(Z_ARRVAL_P(php_data));
	data = emalloc(len * sizeof(char *));
	for (zend_hash_internal_pointer_reset(Z_ARRVAL_P(php_data));
		 zend_hash_get_current_data(Z_ARRVAL_P(php_data), (void **)&line) == SUCCESS;
		 zend_hash_move_forward(Z_ARRVAL_P(php_data))) {
		convert_to_string_ex(line);
		data[i++] = Z_STRVAL_PP(line);
	}

	pixmap = gdk_pixmap_colormap_create_from_xpm_d(window, colormap, &mask, trans_color, data);
	efree(data);
	if (!pixmap) {
		php_error(E_WARNING, "%s() cannot create pixmap", get_active_function_name(TSRMLS_C));
		return;
	}

	*return_value = *php_gtk_build_value("(NN)", php_gdk_pixmap_new(pixmap), php_gdk_bitmap_new(mask));
	gdk_pixmap_unref(pixmap);
	gdk_bitmap_unref(mask);
}

PHP_FUNCTION(gdk_colormap_new)
{
	zval *visual;
	zend_bool allocate;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "Ob", &visual, gdk_visual_ce, &allocate))
		return;

	PHP_GTK_SEPARATE_RETURN(return_value, php_gdk_colormap_new(gdk_colormap_new(PHP_GDK_VISUAL_GET(visual), (gboolean)allocate)));
	return;
}


PHP_FUNCTION(gdk_colormap_get_system)
{
	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	PHP_GTK_SEPARATE_RETURN(return_value, php_gdk_colormap_new(gdk_colormap_get_system()));
	return;
}


PHP_FUNCTION(gdk_colormap_get_system_size)
{
	long php_retval;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	php_retval = gdk_colormap_get_system_size();
	RETURN_LONG(php_retval);
}

PHP_FUNCTION(gdk_color_parse)
{
	gchar *color_spec;
	GdkColor color;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "s", &color_spec)) {
		return;
	}

	if (gdk_color_parse(color_spec, &color))
		*return_value = *php_gdk_color_new(&color);
	else
		php_error(E_WARNING, "%s() could not parse color spec '%s'", get_active_function_name(TSRMLS_C), color_spec);
}

PHP_FUNCTION(gdk_font_load)
{
	char *font_name;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "s", &font_name))
		return;

	PHP_GTK_SEPARATE_RETURN(return_value, php_gdk_font_new(gdk_font_load(font_name)));
	return;
}


PHP_FUNCTION(gdk_fontset_load)
{
	char *fontset_name;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "s", &fontset_name))
		return;

	PHP_GTK_SEPARATE_RETURN(return_value, php_gdk_font_new(gdk_fontset_load(fontset_name)));
	return;
}


PHP_FUNCTION(gdk_draw_point)
{
	GdkDrawable *drawable;
	zval *php_drawable, *gc;
	long x, y;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "VOii", &php_drawable, &gc, gdk_gc_ce, &x, &y))
		return;

	if (php_gtk_check_class(php_drawable, gdk_window_ce))
							drawable = (GdkDrawable *)PHP_GDK_WINDOW_GET(php_drawable);
						else if(php_gtk_check_class(php_drawable, gdk_pixmap_ce))
							drawable = (GdkDrawable *)PHP_GDK_PIXMAP_GET(php_drawable);
						else if(php_gtk_check_class(php_drawable, gdk_bitmap_ce))
							drawable = (GdkDrawable *)PHP_GDK_BITMAP_GET(php_drawable);
						else {
								php_error(E_WARNING, "%s() expects the drawable to be GdkWindow, GdkPixmap, or GdkBitmap", get_active_function_name(TSRMLS_C));
								return;
						}
					gdk_draw_point(drawable, PHP_GDK_GC_GET(gc), (gint)x, (gint)y);
	RETURN_NULL();
}


PHP_FUNCTION(gdk_draw_line)
{
	GdkDrawable *drawable;
	zval *php_drawable, *gc;
	long x1, y1, x2, y2;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "VOiiii", &php_drawable, &gc, gdk_gc_ce, &x1, &y1, &x2, &y2))
		return;

	if (php_gtk_check_class(php_drawable, gdk_window_ce))
							drawable = (GdkDrawable *)PHP_GDK_WINDOW_GET(php_drawable);
						else if(php_gtk_check_class(php_drawable, gdk_pixmap_ce))
							drawable = (GdkDrawable *)PHP_GDK_PIXMAP_GET(php_drawable);
						else if(php_gtk_check_class(php_drawable, gdk_bitmap_ce))
							drawable = (GdkDrawable *)PHP_GDK_BITMAP_GET(php_drawable);
						else {
								php_error(E_WARNING, "%s() expects the drawable to be GdkWindow, GdkPixmap, or GdkBitmap", get_active_function_name(TSRMLS_C));
								return;
						}
					gdk_draw_line(drawable, PHP_GDK_GC_GET(gc), (gint)x1, (gint)y1, (gint)x2, (gint)y2);
	RETURN_NULL();
}


PHP_FUNCTION(gdk_draw_rectangle)
{
	GdkDrawable *drawable;
	zval *php_drawable, *gc;
	long filled, x, y, width, height;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "VOiiiii", &php_drawable, &gc, gdk_gc_ce, &filled, &x, &y, &width, &height))
		return;

	if (php_gtk_check_class(php_drawable, gdk_window_ce))
							drawable = (GdkDrawable *)PHP_GDK_WINDOW_GET(php_drawable);
						else if(php_gtk_check_class(php_drawable, gdk_pixmap_ce))
							drawable = (GdkDrawable *)PHP_GDK_PIXMAP_GET(php_drawable);
						else if(php_gtk_check_class(php_drawable, gdk_bitmap_ce))
							drawable = (GdkDrawable *)PHP_GDK_BITMAP_GET(php_drawable);
						else {
								php_error(E_WARNING, "%s() expects the drawable to be GdkWindow, GdkPixmap, or GdkBitmap", get_active_function_name(TSRMLS_C));
								return;
						}
					gdk_draw_rectangle(drawable, PHP_GDK_GC_GET(gc), (gint)filled, (gint)x, (gint)y, (gint)width, (gint)height);
	RETURN_NULL();
}


PHP_FUNCTION(gdk_draw_arc)
{
	GdkDrawable *drawable;
	zval *php_drawable, *gc;
	long filled, x, y, width, height, angle1, angle2;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "VOiiiiiii", &php_drawable, &gc, gdk_gc_ce, &filled, &x, &y, &width, &height, &angle1, &angle2))
		return;

	if (php_gtk_check_class(php_drawable, gdk_window_ce))
							drawable = (GdkDrawable *)PHP_GDK_WINDOW_GET(php_drawable);
						else if(php_gtk_check_class(php_drawable, gdk_pixmap_ce))
							drawable = (GdkDrawable *)PHP_GDK_PIXMAP_GET(php_drawable);
						else if(php_gtk_check_class(php_drawable, gdk_bitmap_ce))
							drawable = (GdkDrawable *)PHP_GDK_BITMAP_GET(php_drawable);
						else {
								php_error(E_WARNING, "%s() expects the drawable to be GdkWindow, GdkPixmap, or GdkBitmap", get_active_function_name(TSRMLS_C));
								return;
						}
					gdk_draw_arc(drawable, PHP_GDK_GC_GET(gc), (gint)filled, (gint)x, (gint)y, (gint)width, (gint)height, (gint)angle1, (gint)angle2);
	RETURN_NULL();
}


PHP_FUNCTION(gdk_draw_string)
{
	GdkDrawable *drawable;
	zval *php_drawable, *font, *gc;
	long x, y;
	char *string;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "VOOiis", &php_drawable, &font, gdk_font_ce, &gc, gdk_gc_ce, &x, &y, &string))
		return;

	if (php_gtk_check_class(php_drawable, gdk_window_ce))
							drawable = (GdkDrawable *)PHP_GDK_WINDOW_GET(php_drawable);
						else if(php_gtk_check_class(php_drawable, gdk_pixmap_ce))
							drawable = (GdkDrawable *)PHP_GDK_PIXMAP_GET(php_drawable);
						else if(php_gtk_check_class(php_drawable, gdk_bitmap_ce))
							drawable = (GdkDrawable *)PHP_GDK_BITMAP_GET(php_drawable);
						else {
								php_error(E_WARNING, "%s() expects the drawable to be GdkWindow, GdkPixmap, or GdkBitmap", get_active_function_name(TSRMLS_C));
								return;
						}
					gdk_draw_string(drawable, PHP_GDK_FONT_GET(font), PHP_GDK_GC_GET(gc), (gint)x, (gint)y, string);
	RETURN_NULL();
}


PHP_FUNCTION(gdk_draw_text)
{
	GdkDrawable *drawable;
	zval *php_drawable, *font, *gc;
	long x, y, text_length;
	char *text;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "VOOiisi", &php_drawable, &font, gdk_font_ce, &gc, gdk_gc_ce, &x, &y, &text, &text_length))
		return;

	if (php_gtk_check_class(php_drawable, gdk_window_ce))
							drawable = (GdkDrawable *)PHP_GDK_WINDOW_GET(php_drawable);
						else if(php_gtk_check_class(php_drawable, gdk_pixmap_ce))
							drawable = (GdkDrawable *)PHP_GDK_PIXMAP_GET(php_drawable);
						else if(php_gtk_check_class(php_drawable, gdk_bitmap_ce))
							drawable = (GdkDrawable *)PHP_GDK_BITMAP_GET(php_drawable);
						else {
								php_error(E_WARNING, "%s() expects the drawable to be GdkWindow, GdkPixmap, or GdkBitmap", get_active_function_name(TSRMLS_C));
								return;
						}
					gdk_draw_text(drawable, PHP_GDK_FONT_GET(font), PHP_GDK_GC_GET(gc), (gint)x, (gint)y, text, (gint)text_length);
	RETURN_NULL();
}


PHP_FUNCTION(gdk_draw_pixmap_int)
{
	GdkDrawable *drawable, *src;
	zval *php_drawable, *gc, *php_src;
	long xsrc, ysrc, xdest, ydest, width, height;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "VOViiiiii", &php_drawable, &gc, gdk_gc_ce, &php_src, &xsrc, &ysrc, &xdest, &ydest, &width, &height))
		return;

	if (php_gtk_check_class(php_drawable, gdk_window_ce))
							drawable = (GdkDrawable *)PHP_GDK_WINDOW_GET(php_drawable);
						else if(php_gtk_check_class(php_drawable, gdk_pixmap_ce))
							drawable = (GdkDrawable *)PHP_GDK_PIXMAP_GET(php_drawable);
						else if(php_gtk_check_class(php_drawable, gdk_bitmap_ce))
							drawable = (GdkDrawable *)PHP_GDK_BITMAP_GET(php_drawable);
						else {
								php_error(E_WARNING, "%s() expects the drawable to be GdkWindow, GdkPixmap, or GdkBitmap", get_active_function_name(TSRMLS_C));
								return;
						}
					if (php_gtk_check_class(php_src, gdk_window_ce))
							src = (GdkDrawable *)PHP_GDK_WINDOW_GET(php_src);
						else if(php_gtk_check_class(php_src, gdk_pixmap_ce))
							src = (GdkDrawable *)PHP_GDK_PIXMAP_GET(php_src);
						else if(php_gtk_check_class(php_src, gdk_bitmap_ce))
							src = (GdkDrawable *)PHP_GDK_BITMAP_GET(php_src);
						else {
								php_error(E_WARNING, "%s() expects the drawable to be GdkWindow, GdkPixmap, or GdkBitmap", get_active_function_name(TSRMLS_C));
								return;
						}
					gdk_draw_pixmap(drawable, PHP_GDK_GC_GET(gc), src, (gint)xsrc, (gint)ysrc, (gint)xdest, (gint)ydest, (gint)width, (gint)height);
	RETURN_NULL();
}


PHP_FUNCTION(gdk_atom_intern)
{
	char *atom_name;
	long only_if_exists = FALSE;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "s|i", &atom_name, &only_if_exists))
		return;

	*return_value = *php_gdk_atom_new(gdk_atom_intern(atom_name, (gint)only_if_exists));
	return;
}


PHP_FUNCTION(gdk_threads_enter)
{
	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gdk_threads_enter();
	RETURN_NULL();
}


PHP_FUNCTION(gdk_threads_leave)
{
	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	gdk_threads_leave();
	RETURN_NULL();
}


PHP_FUNCTION(gdk_rgb_xpixel_from_rgb)
{
	long rgb, php_retval;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &rgb))
		return;

	php_retval = gdk_rgb_xpixel_from_rgb((guint32)rgb);
	RETURN_LONG(php_retval);
}


PHP_FUNCTION(gdk_rgb_gc_set_foreground)
{
	zval *gc;
	long rgb;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "Oi", &gc, gdk_gc_ce, &rgb))
		return;

	gdk_rgb_gc_set_foreground(PHP_GDK_GC_GET(gc), (guint32)rgb);
	RETURN_NULL();
}


PHP_FUNCTION(gdk_rgb_gc_set_background)
{
	zval *gc;
	long rgb;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "Oi", &gc, gdk_gc_ce, &rgb))
		return;

	gdk_rgb_gc_set_background(PHP_GDK_GC_GET(gc), (guint32)rgb);
	RETURN_NULL();
}


PHP_FUNCTION(gdk_draw_rgb_image)
{
	GdkDrawable *drawable;
	zval *php_drawable, *gc, *php_dith = NULL;
	long x, y, width, height, rowstride;
	GdkRgbDither dith;
	char *rgb_buf;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "VOiiiiVsi", &php_drawable, &gc, gdk_gc_ce, &x, &y, &width, &height, &php_dith, &rgb_buf, &rowstride))
		return;

	if (php_gtk_check_class(php_drawable, gdk_window_ce))
							drawable = (GdkDrawable *)PHP_GDK_WINDOW_GET(php_drawable);
						else if(php_gtk_check_class(php_drawable, gdk_pixmap_ce))
							drawable = (GdkDrawable *)PHP_GDK_PIXMAP_GET(php_drawable);
						else if(php_gtk_check_class(php_drawable, gdk_bitmap_ce))
							drawable = (GdkDrawable *)PHP_GDK_BITMAP_GET(php_drawable);
						else {
								php_error(E_WARNING, "%s() expects the drawable to be GdkWindow, GdkPixmap, or GdkBitmap", get_active_function_name(TSRMLS_C));
								return;
						}
					if (php_dith && !php_gtk_get_enum_value(GTK_TYPE_GDK_RGB_DITHER, php_dith, (gint *)&dith)) {
		return;
	}

	gdk_draw_rgb_image(drawable, PHP_GDK_GC_GET(gc), (gint)x, (gint)y, (gint)width, (gint)height, dith, rgb_buf, (gint)rowstride);
	RETURN_NULL();
}


PHP_FUNCTION(gdk_draw_rgb_image_dithalign)
{
	GdkDrawable *drawable;
	zval *php_drawable, *gc, *php_dith = NULL;
	long x, y, width, height, rowstride, xdith, ydith;
	GdkRgbDither dith;
	char *rgb_buf;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "VOiiiiVsiii", &php_drawable, &gc, gdk_gc_ce, &x, &y, &width, &height, &php_dith, &rgb_buf, &rowstride, &xdith, &ydith))
		return;

	if (php_gtk_check_class(php_drawable, gdk_window_ce))
							drawable = (GdkDrawable *)PHP_GDK_WINDOW_GET(php_drawable);
						else if(php_gtk_check_class(php_drawable, gdk_pixmap_ce))
							drawable = (GdkDrawable *)PHP_GDK_PIXMAP_GET(php_drawable);
						else if(php_gtk_check_class(php_drawable, gdk_bitmap_ce))
							drawable = (GdkDrawable *)PHP_GDK_BITMAP_GET(php_drawable);
						else {
								php_error(E_WARNING, "%s() expects the drawable to be GdkWindow, GdkPixmap, or GdkBitmap", get_active_function_name(TSRMLS_C));
								return;
						}
					if (php_dith && !php_gtk_get_enum_value(GTK_TYPE_GDK_RGB_DITHER, php_dith, (gint *)&dith)) {
		return;
	}

	gdk_draw_rgb_image_dithalign(drawable, PHP_GDK_GC_GET(gc), (gint)x, (gint)y, (gint)width, (gint)height, dith, rgb_buf, (gint)rowstride, (gint)xdith, (gint)ydith);
	RETURN_NULL();
}


PHP_FUNCTION(gdk_draw_rgb_32_image)
{
	GdkDrawable *drawable;
	zval *php_drawable, *gc, *php_dith = NULL;
	long x, y, width, height, rowstride;
	GdkRgbDither dith;
	char *buf;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "VOiiiiVsi", &php_drawable, &gc, gdk_gc_ce, &x, &y, &width, &height, &php_dith, &buf, &rowstride))
		return;

	if (php_gtk_check_class(php_drawable, gdk_window_ce))
							drawable = (GdkDrawable *)PHP_GDK_WINDOW_GET(php_drawable);
						else if(php_gtk_check_class(php_drawable, gdk_pixmap_ce))
							drawable = (GdkDrawable *)PHP_GDK_PIXMAP_GET(php_drawable);
						else if(php_gtk_check_class(php_drawable, gdk_bitmap_ce))
							drawable = (GdkDrawable *)PHP_GDK_BITMAP_GET(php_drawable);
						else {
								php_error(E_WARNING, "%s() expects the drawable to be GdkWindow, GdkPixmap, or GdkBitmap", get_active_function_name(TSRMLS_C));
								return;
						}
					if (php_dith && !php_gtk_get_enum_value(GTK_TYPE_GDK_RGB_DITHER, php_dith, (gint *)&dith)) {
		return;
	}

	gdk_draw_rgb_32_image(drawable, PHP_GDK_GC_GET(gc), (gint)x, (gint)y, (gint)width, (gint)height, dith, buf, (gint)rowstride);
	RETURN_NULL();
}


PHP_FUNCTION(gdk_draw_gray_image)
{
	GdkDrawable *drawable;
	zval *php_drawable, *gc, *php_dith = NULL;
	long x, y, width, height, rowstride;
	GdkRgbDither dith;
	char *buf;

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "VOiiiiVsi", &php_drawable, &gc, gdk_gc_ce, &x, &y, &width, &height, &php_dith, &buf, &rowstride))
		return;

	if (php_gtk_check_class(php_drawable, gdk_window_ce))
							drawable = (GdkDrawable *)PHP_GDK_WINDOW_GET(php_drawable);
						else if(php_gtk_check_class(php_drawable, gdk_pixmap_ce))
							drawable = (GdkDrawable *)PHP_GDK_PIXMAP_GET(php_drawable);
						else if(php_gtk_check_class(php_drawable, gdk_bitmap_ce))
							drawable = (GdkDrawable *)PHP_GDK_BITMAP_GET(php_drawable);
						else {
								php_error(E_WARNING, "%s() expects the drawable to be GdkWindow, GdkPixmap, or GdkBitmap", get_active_function_name(TSRMLS_C));
								return;
						}
					if (php_dith && !php_gtk_get_enum_value(GTK_TYPE_GDK_RGB_DITHER, php_dith, (gint *)&dith)) {
		return;
	}

	gdk_draw_gray_image(drawable, PHP_GDK_GC_GET(gc), (gint)x, (gint)y, (gint)width, (gint)height, dith, buf, (gint)rowstride);
	RETURN_NULL();
}


PHP_FUNCTION(gdk_rgb_get_cmap)
{
	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	PHP_GTK_SEPARATE_RETURN(return_value, php_gdk_colormap_new(gdk_rgb_get_cmap()));
	return;
}


PHP_FUNCTION(gdk_rgb_get_visual)
{
	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	PHP_GTK_SEPARATE_RETURN(return_value, php_gdk_visual_new(gdk_rgb_get_visual()));
	return;
}

PHP_GTK_EXPORT_CE(gdk_ce);

static function_entry php_gdk_functions[] = {
	{"get_display",	PHP_FN(gdk_get_display),	NULL},
	{"input_remove",	PHP_FN(gdk_input_remove),	NULL},
	{"pointer_grab",	PHP_FN(gdk_pointer_grab),	NULL},
	{"pointer_ungrab",	PHP_FN(gdk_pointer_ungrab),	NULL},
	{"keyboard_grab",	PHP_FN(gdk_keyboard_grab),	NULL},
	{"keyboard_ungrab",	PHP_FN(gdk_keyboard_ungrab),	NULL},
	{"pointer_is_grabbed",	PHP_FN(gdk_pointer_is_grabbed),	NULL},
	{"screen_width",	PHP_FN(gdk_screen_width),	NULL},
	{"screen_height",	PHP_FN(gdk_screen_height),	NULL},
	{"screen_width_mm",	PHP_FN(gdk_screen_width_mm),	NULL},
	{"screen_height_mm",	PHP_FN(gdk_screen_height_mm),	NULL},
	{"flush",	PHP_FN(gdk_flush),	NULL},
	{"beep",	PHP_FN(gdk_beep),	NULL},
	{"visual_get_system",	PHP_FN(gdk_visual_get_system),	NULL},
	{"visual_get_best",	PHP_FN(gdk_visual_get_best),	NULL},
	{"visual_get_best_with_depth",	PHP_FN(gdk_visual_get_best_with_depth),	NULL},
	{"visual_get_best_with_type",	PHP_FN(gdk_visual_get_best_with_type),	NULL},
	{"visual_get_best_with_both",	PHP_FN(gdk_visual_get_best_with_both),	NULL},
	{"drag_status",	PHP_FN(gdk_drag_status),	NULL},
	{"cursor_new",	PHP_FN(gdk_cursor_new),	NULL},
	{"cursor_new_from_pixmap",	PHP_FN(gdk_cursor_new_from_pixmap),	NULL},
	{"pixmap_create_from_xpm",	PHP_FN(gdk_pixmap_create_from_xpm),	NULL},
	{"pixmap_colormap_create_from_xpm",	PHP_FN(gdk_pixmap_colormap_create_from_xpm),	NULL},
	{"pixmap_create_from_xpm_d",	PHP_FN(gdk_pixmap_create_from_xpm_d),	NULL},
	{"pixmap_colormap_create_from_xpm_d",	PHP_FN(gdk_pixmap_colormap_create_from_xpm_d),	NULL},
	{"colormap_new",	PHP_FN(gdk_colormap_new),	NULL},
	{"colormap_get_system",	PHP_FN(gdk_colormap_get_system),	NULL},
	{"colormap_get_system_size",	PHP_FN(gdk_colormap_get_system_size),	NULL},
	{"color_parse",	PHP_FN(gdk_color_parse),	NULL},
	{"font_load",	PHP_FN(gdk_font_load),	NULL},
	{"fontset_load",	PHP_FN(gdk_fontset_load),	NULL},
	{"draw_point",	PHP_FN(gdk_draw_point),	NULL},
	{"draw_line",	PHP_FN(gdk_draw_line),	NULL},
	{"draw_rectangle",	PHP_FN(gdk_draw_rectangle),	NULL},
	{"draw_arc",	PHP_FN(gdk_draw_arc),	NULL},
	{"draw_string",	PHP_FN(gdk_draw_string),	NULL},
	{"draw_text",	PHP_FN(gdk_draw_text),	NULL},
	{"draw_pixmap",	PHP_FN(gdk_draw_pixmap_int),	NULL},
	{"atom_intern",	PHP_FN(gdk_atom_intern),	NULL},
	{"threads_enter",	PHP_FN(gdk_threads_enter),	NULL},
	{"threads_leave",	PHP_FN(gdk_threads_leave),	NULL},
	{"rgb_xpixel_from_rgb",	PHP_FN(gdk_rgb_xpixel_from_rgb),	NULL},
	{"rgb_gc_set_foreground",	PHP_FN(gdk_rgb_gc_set_foreground),	NULL},
	{"rgb_gc_set_background",	PHP_FN(gdk_rgb_gc_set_background),	NULL},
	{"draw_rgb_image",	PHP_FN(gdk_draw_rgb_image),	NULL},
	{"draw_rgb_image_dithalign",	PHP_FN(gdk_draw_rgb_image_dithalign),	NULL},
	{"draw_rgb_32_image",	PHP_FN(gdk_draw_rgb_32_image),	NULL},
	{"draw_gray_image",	PHP_FN(gdk_draw_gray_image),	NULL},
	{"rgb_get_cmap",	PHP_FN(gdk_rgb_get_cmap),	NULL},
	{"rgb_get_visual",	PHP_FN(gdk_rgb_get_visual),	NULL},
	{NULL, NULL, NULL}
};


/* struct GdkRectangle */

zval *PHP_GTK_EXPORT_FUNC(php_gdk_rectangle_new)(GdkRectangle *obj)
{
	zval *result;
	TSRMLS_FETCH();

    if (!obj) {
        MAKE_STD_ZVAL(result);
        ZVAL_NULL(result);
        return result;
    }

    MAKE_STD_ZVAL(result);
    object_init_ex(result, gdk_rectangle_ce);

	add_property_long(result, "x", obj->x);
	add_property_long(result, "y", obj->y);
	add_property_long(result, "width", obj->width);
	add_property_long(result, "height", obj->height);

    return result;
}


zend_bool PHP_GTK_EXPORT_FUNC(php_gdk_rectangle_get)(zval *wrapper, GdkRectangle *obj)
{
    zval **item;
	TSRMLS_FETCH();

    if (!php_gtk_check_class(wrapper, gdk_rectangle_ce))
        return 0;

	if (zend_hash_find(Z_OBJPROP_P(wrapper), "x", sizeof("x"), (void **)&item) == SUCCESS && Z_TYPE_PP(item) == IS_LONG)
		obj->x = (gint16)Z_LVAL_PP(item);
	else
		return 0;

	if (zend_hash_find(Z_OBJPROP_P(wrapper), "y", sizeof("y"), (void **)&item) == SUCCESS && Z_TYPE_PP(item) == IS_LONG)
		obj->y = (gint16)Z_LVAL_PP(item);
	else
		return 0;

	if (zend_hash_find(Z_OBJPROP_P(wrapper), "width", sizeof("width"), (void **)&item) == SUCCESS && Z_TYPE_PP(item) == IS_LONG)
		obj->width = (guint16)Z_LVAL_PP(item);
	else
		return 0;

	if (zend_hash_find(Z_OBJPROP_P(wrapper), "height", sizeof("height"), (void **)&item) == SUCCESS && Z_TYPE_PP(item) == IS_LONG)
		obj->height = (guint16)Z_LVAL_PP(item);
	else
		return 0;


    return 1;
}


PHP_FUNCTION(gdkrectangle)
{
	long x, y, width, height;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "iiii", &x, &y, &width, &height)) {
		php_gtk_invalidate(this_ptr);
		return;
	}

	add_property_long(this_ptr, "x", x);
	add_property_long(this_ptr, "y", y);
	add_property_long(this_ptr, "width", width);
	add_property_long(this_ptr, "height", height);
}


static function_entry php_gdk_rectangle_functions[] = {
	{"GdkRectangle",	PHP_FN(gdkrectangle),	NULL},
	{"gdkrectangle",	PHP_FN(gdkrectangle),	NULL},
	{NULL, NULL, NULL}
};


void php_gdk_register_classes(void)
{
	zend_class_entry ce;
	TSRMLS_FETCH();

	INIT_OVERLOADED_CLASS_ENTRY(ce, "Gdk", php_gdk_functions, NULL, NULL, php_gtk_set_property);
	gdk_ce = zend_register_internal_class_ex(&ce, NULL, NULL TSRMLS_CC);

	INIT_CLASS_ENTRY(ce, "GdkRectangle", php_gdk_rectangle_functions);
	gdk_rectangle_ce = zend_register_internal_class_ex(&ce, NULL, NULL TSRMLS_CC);


}

#endif /* HAVE_PHP_GTK */
